#!/usr/bin/env bash

ocamlc -i expr.ml > expr.mli
ocamlc expr.mli
ocamlc expr.ml

menhir --infer myparser.mly
ocamlc myparser.mli
ocamlc myparser.ml

ocamllex mylexer.mll
ocamlc mylexer.ml

ocamlc expr.cmo myparser.cmo mylexer.cmo main.ml

# $ utop
# > #load "expr.cmo";;
# > #load "myparser.cmo";;
# > #load "mylexer.cmo";;
# > Myparser.prog Mylexer.read (Lexing.from_string "3 + 4 - 5");;
# > let parse str = Myparser.prog Mylexer.read (Lexing.from_string str) |> Option.get;;
# > let eval str = str |> Lexing.from_string
#                      |> Myparser.prog Mylexer.read
#                      |> Option.get
#                      |> Expr.eval;;

# To clean:
# rm -f *.cmi *.cmo *.mli mylexer.ml myparser.ml
