%token RPAREN
%token LPAREN
%token PLUS
%token MINUS
%token <int> INT
%token EOF

%start <Expr.expr> prog

%%

(* vvvv ---- Non-terminal symbol. *)
prog:
  | e = expr; EOF { e }
  ;

(* 9 - 2 - 3
   (9 - 2) - 3 to
   9 - (2 - 3) *)
(* vvvv ---- Non-terminal symbol. *)
expr:
  | s = INT { Expr.Int s } (* <<<<<<------- Rules,
                                    Expansion rules *)
            (* vvvv ------ Terminal symbol. *)
  | el = expr; PLUS; er = expr { Expr.Plus(el, er) }
  | el = expr; MINUS; er = expr {Expr.Minus(el, er) }
  | LPAREN; e = expr; RPAREN { e }
  ;

(* (* myparser.mly:
   .ml
   .mly: Menhir
   .y: YACC --> Menhir
            --> Bison *)

expr ::= 0 | 1 | 2 | ... (Constant integer)
       | INT (Constant integer)
       | expr '+' expr   (Addition)
       | expr '-' expr   (Minus)
       | '(' expr ')'    (Parentheses)

(* 1. Everything you can produce using this recipe is an expression.
   2. Every expression you can produce in this way. There is
      nothing else. The world is closed. *)
   3 * 4 (Because of property 2, this is not an expression)
   3 + (4 - 5)
     +        - Rule 1.8
       (     )- Rule 1.10
          -   - Rule 1.9
        4     - Rule 1.7
            5 - Rule 1.7

  45  ----- "Int 45"

1
1 + 1
1 + 1 + 1
1 + 1 + 1 + 1
... *)